#!/usr/bin/python2.7
#flashprog16wd.py

#Wesentliche Hinweise zur ISP-Programmierung
#von Atmel-Controllern finden sich neben 
#den Angaben in den Datenblaettern der betreffenden #Mikrocontroller u. a. in inzwischen vergriffenen #Fachbuechern von W.Trampert sowie B.Kainka (vgl #Literaturangaben zum Beitrag).

#H. Nieder, Fruehjahr 2015
#aktualisierte Version vom Januar 2016

import sys
import time
import RPi.GPIO as GPIO


#GPIO-Pins
MOSI=8
SCK =7
MISO=25
RES=23
#Test-GPIO aus der Entwicklungsphase
#des Programms, fuer Erweiterungen 
STR=24

page_low=(0x00,0x10,0x20,0x30,0x40,0x50,0x60,0x70,0x80,0x90,
0xA0,0xB0,0xC0,0xD0,0xE0,0xF0,0x00,0x10,0x20,0x30,0x40,
0x50,0x60,0x70,0x80,0x90,0xA0,0xB0,0xC0,0xD0,0xE0,0xF0,
0x00,0x10,0x20,0x30,0x40,0x50,0x60,0x70,0x80,0x90,
0xA0,0xB0,0xC0,0xD0,0xE0,0xF0,0x00,0x10,0x20,0x30,
0x40,0x50,0x60,0x70,0x80,0x90,0xA0,0xB0,0xC0,0xD0,0xE0,0xF0)

page_hi=(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,
2,2,2,2,2,2,2,2,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3)

#GPIO-Festlegungen
GPIO.setmode(GPIO.BCM)
GPIO.setwarnings(False)

GPIO.setup(MOSI,GPIO.OUT)
GPIO.setup(SCK,GPIO.OUT)
GPIO.setup(STR,GPIO.OUT)
GPIO.setup(RES,GPIO.OUT)
GPIO.setup(MISO,GPIO.IN)

#"Umbennungen" fuer GPIO.output etc.  
out=GPIO.output
inp=GPIO.input
low=GPIO.LOW
hi=GPIO.HIGH

#Anfangszustand
out(STR,hi)
out(RES,low)
Byte=0
z=0
k=0
wordzahl=0
zahl2er=0
page_r=0

def pulse_STR():
    out(STR,low)
    time.sleep(0.005)
    out(STR,hi)

def SPI_aus(Byte):
    Byte=255-Byte 
    Bit7_wt=128
    n=0
    for n in range(0,8):
        if (Byte & Bit7_wt) >0:
            out(MOSI,hi)      
        else:
            out(MOSI,low)
        time.sleep(0.00002)
        out(SCK,low)
        Bit7_wt=Bit7_wt>>1#1 Bit nach rechts schieben
        
        time.sleep(0.00002)
        out(SCK,hi)
    
    out(MOSI,hi)
    time.sleep(0.01)
    pulse_STR()#kann entfallen

global Hexzahl
def HexToInt(Hexzahl):
    H=0
    L=0
    Hnib=Hexzahl[0:1]
    
    H= ord(Hnib)-48
    
    if H>9:
        H=H-7
    Lnib=Hexzahl[1:2]
    
    L= ord(Lnib)-48
        
    if L>9:
        L=L-7
    Ergebnis=16*H+L
    Byte=Ergebnis
    return Byte

def prog_en():
    SPI_aus(0xAC)
    SPI_aus(0x53)
    SPI_aus(0)
    SPI_aus(0)    

def erase():
    SPI_aus(0xAC)
    SPI_aus(0x80)
    SPI_aus(0)
    SPI_aus(0)

r=130
anzahl=0
wordzahl=0
zahl=0
zahl2er=0
zahl1er=0
page_r=0


def load_prog_mem_page_lo2():
    global z
    
    dat_zeile=dat_str
    for p in range(0,8):
        SPI_aus(0x40)
        SPI_aus(0x00)
        SPI_aus(p)
        
        Hexzahl=dat_zeile[z+0+p*4:z+2+p*4]
        
        Byte=HexToInt(Hexzahl)
        SPI_aus(Byte)

        SPI_aus(0x48)
        SPI_aus(0x00)
        SPI_aus(p)
        Hexzahl=dat_zeile[z+2+p*4:z+4+p*4]
       
        Byte=HexToInt(Hexzahl)
        SPI_aus(Byte)
    

def load_prog_mem_page_lo2_r():
    global z
    
    dat_zeile=dat_str
    for p in range(0,page_r2):
        SPI_aus(0x40)
        SPI_aus(0x00)
        SPI_aus(p)
        
        Hexzahl=dat_zeile[z+0+p*4:z+2+p*4]
        
        Byte=HexToInt(Hexzahl)
        SPI_aus(Byte)

        SPI_aus(0x48)
        SPI_aus(0x00)
        SPI_aus(p)
        Hexzahl=dat_zeile[z+2+p*4:z+4+p*4]
        
        Byte=HexToInt(Hexzahl)
        SPI_aus(Byte)
    

def load_prog_mem_page_hi2():
    global z
    dat_zeile=dat_str
    for p in range(0,8):
        SPI_aus(0x40)
        SPI_aus(0x00)
        SPI_aus(p+8)
        
        Hexzahl=dat_zeile[z+0+p*4:z+2+p*4]
        
        Byte=HexToInt(Hexzahl)
        SPI_aus(Byte)

        SPI_aus(0x48)
        SPI_aus(0x00)
        SPI_aus(p+8)
        Hexzahl=dat_zeile[z+2+p*4:z+4+p*4]
        
        Byte=HexToInt(Hexzahl)
        SPI_aus(Byte)
    

def load_prog_mem_page_hi2_r():
    global z
    dat_zeile=dat_str
    for p in range(0,page_r2):
        SPI_aus(0x40)
        SPI_aus(0x00)
        SPI_aus(p+8)
        
        Hexzahl=dat_zeile[z+0+p*4:z+2+p*4]
        
        Byte=HexToInt(Hexzahl)
        SPI_aus(Byte)

        SPI_aus(0x48)
        SPI_aus(0x00)
        SPI_aus(p+8)
        Hexzahl=dat_zeile[z+2+p*4:z+4+p*4]
        
        Byte=HexToInt(Hexzahl)
        SPI_aus(Byte)

def anzahl_lesen2():
    anzahl=0
    r=2048
    global page_z
    global page_r
    global page_r2
    global page_r1
    
    global dat_str
    hexdatei=open(hex_datei)
    dat_str=""
    for k in range(0,r):
        dat_zeile=hexdatei.readline()
        
        dat_ZL=dat_zeile[9:len(dat_zeile)-4]
        dat_str=dat_str+dat_ZL
        
        
        Hexzahl=dat_zeile[1:3]
        if Hexzahl=="00":
            break
        anzahl=anzahl+ Byte
    dat_str_test=dat_str[0:4]  
    
    if dat_str_test=="0000":
    
        dat_str=dat_str[4:len(dat_str)]
    
    
    anzahl=len(dat_str)/2 
    print "Words: ",anzahl/2
    page_z=anzahl/32
    print "Vollst. Pages: ",page_z
    page_r=anzahl%32
    print "Restl. Bytes: ",page_r
    page_r1=page_r/16
    page_r2=(page_r%16)/2
    print "Vollst. halbe Pages: ",page_r1
    print "Restl.Words: ",page_r2
    hexdatei.close() 
    time.sleep(2)  
  

def Block_write():
    global z 
    global k
    global page_z
    for k in range(0,page_z):
        load_prog_mem_page_lo2()
        z=z+32
        
        load_prog_mem_page_hi2()
               
        SPI_aus(0x4C)
        SPI_aus(page_hi[k])
        
        SPI_aus(page_low[k])
        
        SPI_aus(0x00) 
        z=(k+1)*64
        

def Block_r1_write():
    global z 
    global k
    global page_r
    load_prog_mem_page_lo2()
  
def Block_r2_write_lo():
    global z 
    global k
    global page_r2
    load_prog_mem_page_lo2_r()
   
def Block_r2_write_hi():
    global z 
    global k
    global page_r2
    load_prog_mem_page_hi2_r()
 

hex_datei=raw_input("HEX-Datei: ")

try:
    hexdatei=open(hex_datei)
except:
    print"Fehler im Dateinamen"
    sys.exit(0)


anzahl_lesen2()

hexdatei.close()

out(RES,hi)

time.sleep(0.02)
prog_en()
time.sleep(0.02)

erase()
time.sleep(0.02)


if page_z>=1:
   Block_write()
   
   print

if page_r1==0:
    if page_r2>0:
        
        Block_r2_write_lo()        
   
    k=k+1                   
    SPI_aus(0x4C)
    SPI_aus(page_hi[k])
    
    SPI_aus(page_low[k])
   
    SPI_aus(0x00) 
    z=z+4*page_r2
    


if page_r1==1:
  
    if page_r2>0:
        Block_r1_write()
        z=z+32
        Block_r2_write_hi() 
    if page_r2==0:
        Block_r1_write()
    
    k=k+1
    SPI_aus(0x4C)
    SPI_aus(page_hi[k])
   
    SPI_aus(page_low[k])
    
    SPI_aus(0x00) 
    z=z+4*page_r2
    

   
hexdatei.close()
print "Programmierung beendet"
print 
time.sleep(1)

out(MOSI,low)
out(SCK,low)
time.sleep(1)
out(RES,low)

